<template>
    <div>
        <Fieldset :title="props.title">

            <FormInput v-model="plan.nom"
                       type="text"
                       name="nom"
                       :ref="addFormInputRef"
                       :label="t(props.nomLabel ?? 'plan.nom')"
                       @validated="handleValidation" />
            <FormRow>
                <FormInput v-model="plan.largeur"
                           type="number"
                           name="largeur"
                           :ref="addFormInputRef"
                           :label="t(props.largeurLabel ?? 'plan.largeur')"
                           :rules="[required, min(0), max(6.4)]"
                           @validated="handleValidation" />

                <FormInput v-model="plan.longueur"
                           type="number"
                           name="longueur"
                           :ref="addFormInputRef"
                           :rules="[required, min(0), max(12)]"
                           :label="t(props.longueurLabel ?? 'plan.longueur')"
                           @validated="handleValidation" />
            </FormRow>

        </Fieldset>

    </div>
</template>

<script lang="ts" setup>
import { ref } from "vue";
    import { Status } from "@/validation";
    import { required, min, max } from "@/validation/rules";
import { useI18n } from "vue3-i18n";
import FormInput from "@/components/forms/FormInput.vue";
import Fieldset from "@/components/forms/Fieldset.vue";
    import FormRow from "@/components/forms/FormRow.vue";
    import { PLan } from "@/types/entities/plan";
import FormTextEditor from "@/components/forms/FormTextEditor.vue";


const { t } = useI18n();

// eslint-disable-next-line no-undef
const props = defineProps<{
        plan: PLan,
        title: string,
        nomLabel?: string,
        largeurLabel?: string,
        longueurLabel?: string

}>()

const plan = ref<PLan>(props.plan)


// eslint-disable-next-line
const emit = defineEmits<{
    (event: "handleValidation", name: string, validationStatus: Status): void
    (event: "registerFormInputRef", ref: typeof FormInput): void
}>()


function addFormInputRef(ref: typeof FormInput) {
    emit("registerFormInputRef", ref);
}


async function handleValidation(name: string, validationStatus: Status) {
    emit("handleValidation", name, validationStatus);
}
</script>
